import sys, exceptions, os, optparse
from urlparse import urlunparse
from twisted.python import log
from twisted.internet import reactor
from pyGridWare.common.delegationlib import delegate_cred
from pyGridWare.utility.scripts.client import \
    GetBasicOptParser, GetPortKWArgs, SetUp
from pyGsi import proxylib

import pyGridWare.generated.stubs.delegationservice as DS
DFPortType = DS.DelegationFactoryPortTypeSOAPBindingSOAP
from ZSI.TC import _get_type_definition as TED
from ZSI.TC import _get_global_element_declaration as GED
QueryExpressionType_Def = TED('http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd', "QueryExpressionType")(None)
QueryExpression_Dec = GED('http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd', "QueryExpression")

class OptionHolder: pass
def WsrfQuery(kw, args):
    dPort = DFPortType(**kw)
    getReq = DS.QueryResourcePropertiesRequest()
    getReq.QueryExpression = getReq.new_QueryExpression()
    getReq.QueryExpression._text = args[0] # "count(//*[local-name()='Entry'])"
    if len(args) > 1:
        getReq.QueryExpression.set_attribute_Dialect(args[1])
    else:
        getReq.QueryExpression.set_attribute_Dialect('http://www.w3.org/TR/1999/REC-xpath-19991116')

    getRsp = dPort.QueryResourceProperties(getReq)
    print getRsp._text
    reactor.stop()
    return 0

    
def main():
    ## Simple set of default options.
    options = OptionHolder()
    options.authz= None
    options.m2secureMessage= False
    options.m2crypto= True
    options.m2secureConv= None
    ## TODO: use pyGSI convenience function to retrieve this
    options.cert= '/tmp/x509up_u' + str(os.getuid())
    options.key= None
    options.wsAddressURI= 'http://schemas.xmlsoap.org/ws/2004/03/addressing'


    ## The credential delegate tool doesn't use the same command line
    ## argument as the options parser provided by pyGridWare.
    
    op = optparse.OptionParser()
    op.add_option("-s", "--service", action="store", dest="service",
        help="Service URL", default="https://localhost:8443/wsrf/services/DefaultIndexService")
    op.add_option("-d", "--debug",
        action="store", dest="debug", default=0,
        help="Debug Messages to file, if 1 send to stdout, if 0 then off.")


    (cloptions, args) = op.parse_args()

    if cloptions.debug:
        log.startLogging(sys.stdout)

    options.url=cloptions.service


    """ Convenience method to perform a WSRFQuery """

    options.limited = False
    try:
        kw = GetPortKWArgs(options)
    except proxylib.InvalidProxyException:
        print "Cannot contact service with an invalid proxy"
        return -1

    kw['endPointReference'] = None

    reactor.callWhenRunning(WsrfQuery, kw, args)
    reactor.run()

if __name__ == '__main__':
    main()
