############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
__all__=['GssSecureConversation','GssSecurityContext','GssSignatureHandler', 'GssSecureMessage']
from Ft.Lib import Uuid as _Uuid
from ZSI.TC import _get_global_element_declaration as _GED
from ZSI.wstools.Namespaces import WSTRUST as _WSTRUST

_BinaryExchange = _GED(_WSTRUST.BASE,"BinaryExchange")

def _get_uuid():
    """init context-id
    """
    hcode = _Uuid.UuidAsString(_Uuid.GenerateUuid())
    tmpList = hcode.split('-')
    tmpList[3] = '0' * 8

    tmpList[4] = '0' * 12
    return("-".join(tmpList)) 
    
    
def _is_binary_exchange(any):
    if hasattr(any, 'typecode') and any.typecode is _BinaryExchange:
        return True
    return False
    
