#!/bin/sh

CONFIG=openssl.cnf
CACERT=ca.pem
CAKEY=privkey.pem
SRL=file.srl
DAYS=500
if test $# == 0; then
    CLIENT=client; 
elif test $# == 1; then
    CLIENT=$1
else
    echo "usage: Client.sh [] arg"
    exit -1;
fi

CLIENTKEY=$CLIENT.key
CLIENTCERT=$CLIENT.pem
CLIENTREQ=$CLIENT.req

for i in $CLIENTKEY $CLIENTCERT $CLIENTREQ;  do
    if test -a $i; then
        echo "ERROR: Must remove $i";
        exit -1;
    fi
done

echo 
echo "***********************";
echo "CA passphrase is qwerty";
echo "***********************";
echo 
openssl genrsa -out $CLIENTKEY 1024
openssl req -key $CLIENTKEY -new -out $CLIENTREQ -config $CONFIG -days $DAYS
openssl x509 -req -in $CLIENTREQ -CA $CACERT -CAkey $CAKEY -CAserial $SRL -out $CLIENTCERT  -days $DAYS


